<script lang="ts">
import Vue from 'vue';
import { MrktoForm } from '../common/index.vue';

export default Vue.extend({
  name: 'OpenSourceFormSection',
  components: {
    MrktoForm,
  },
  props: {
    data: {
      type: Object,
      required: true,
    },
  },
  methods: {
    tokenize(value: string) {
      return value.toLowerCase().split(' ').join('-');
    },
  },
});
</script>

<template>
  <section :id="data.id" class="open-source-form-section">
    <SlpContainer>
      <SlpRow>
        <SlpColumn :cols="6" class="slp-pr-md-64">
          <SlpTypography
            :id="tokenize(data.title)"
            class="slp-mb-24"
            tag="p"
            variant="heading2-bold"
            >{{ data.title }}
          </SlpTypography>
          <div
            v-for="block in data.blocks"
            :key="block.title"
            class="open-source-form-section__block"
          >
            <SlpTypography class="slp-mb-24" tag="p" variant="heading5-bold"
              >{{ block.title }}
            </SlpTypography>
            <SlpTypography
              variant="body2"
              class="copy"
              tag="div"
              v-html="$md.render(block.content)"
            ></SlpTypography>
          </div>
          <div v-if="data.disclaimer">
            <SlpTypography
              variant="body2"
              tag="div"
              class="open-source-form-section__disc"
            >
              <SlpIcon
                :name="data.disclaimer.icon.name"
                class="slp-mr-8"
                :variant="data.disclaimer.icon.variant ?? 'product'"
                :alt="data.disclaimer.icon.alt"
                size="sm"
              />
              {{ data.disclaimer.description }}
            </SlpTypography>
          </div>
          <SlpCard200
            v-if="data.card"
            link=""
            class="open-source-form-section__card"
          >
            <SlpTypography class="slp-mb-24" tag="p" variant="heading5-bold"
              >{{ data.card.title }}
            </SlpTypography>
            <SlpTypography
              class="slp-mb-24"
              tag="div"
              variant="body2"
              v-html="$md.render(data.card.description)"
            >
            </SlpTypography>
          </SlpCard200>
        </SlpColumn>
        <SlpColumn :cols="6" class="open-source-form-section__form-wrapper">
          <div class="open-source-form-section__form">
            <MrktoForm v-if="data.form" :data="data.form" />

            <iframe
              v-else
              src="https://offers.sheerid.com/gitlab/member/"
              width="800"
              height="1300"
            ></iframe>
          </div>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.open-source-form-section {
  background: $color-surface-800;
  padding: $spacing-48 0;
  margin: $spacing-48 0 0 0;
  @media (min-width: $breakpoint-lg) {
    padding: $spacing-96 0;
    margin: $spacing-96 0 0 0;
  }
  :deep .slp-text-body2 {
    strong {
      font-weight: bold;
    }
  }
  &__block {
    margin-bottom: $spacing-32;
  }
  &__card {
    cursor: default !important;
    background: $color-surface-50;
    box-shadow: none !important;
    border: 1px solid $color-surface-200;
    margin-bottom: $spacing-48;
    max-width: 100%;
    @media (min-width: $breakpoint-lg) {
      margin-bottom: 0;
    }
  }
  &__form-wrapper {
    width: 100%;
  }

  &__form {
    &:deep(div.mktoOffset) {
      display: none !important;
    }

    &:deep(div.mktoGutter.mktoHasWidth) {
      height: 0 !important;
      margin-bottom: 8px !important;
    }

    iframe {
      width: 100%;
      border: 0;
    }
  }
  &__disc {
    display: flex;
    margin: $spacing-32 0;
  }
}
</style>
